setlocal
call Make-Settings.bat
cd %BASE_DIR%
echo off

rem Create and copy fixes
call :fix BONUS     README   $2000
call :fix BONUS     REALTIME $2000
call :fix DEMO      PROZACDR
call :fix DEMO      UNMEC
call :fix DEMO      WMTRCMNG

call :fix GAME      PANG

call :fix MSX\COVOX BARSZCZ
call :fix MSX\COVOX KASZANKA
call :fix MSX\GTIA  FOXCHASE $4000
call :fix MSX\GTIA  HUMPATAR $4000
call :fix MSX\GTIA  ROCKDAT  $4000
call :fix MSX\GTIA  THEWILDW $4000

call :fix INTRO16K  FIRSTRO
call :fix INTRO16K  NONAME
call :fix INTRO16K  UCIECZKA

call :fix INTRO256  BOBROSS
call :fix INTRO256  MEHCASTE
call :fix INTRO256  WGPL

goto :eof

rem =========
rem Subroutines
rem ==========

rem Compile fix, clear directory and copy fix
:fix

set SOURCE_DIR=atr\fixes\%1\%2
set ENTRY=%2
set TARGET_FILE=%2.xex
set TARGET_DIR=atr\files\%1
set COMPRESS_ADDRESS=%3

echo Fixing %SOURCE_DIR% to %TARGET_DIR%\%TARGET_FILE%
if exist %SOURCE_DIR% goto :fix_dir_exists
echo ERROR: Folder %SOURCE_DIR% does not exist
exit

:fix_dir_exists 
pushd %SOURCE_DIR%
%MADS% -s %ENTRY%.asm -o:%TARGET_FILE%
if ERRORLEVEL 1 goto :mads_error
del /S/Q *.lab   2> NUL
del /S/Q *.lst   2> NUL
del /S/Q *.atdbg 2> NUL
popd

rem If a start address is specified, file is packed instead of being copied.
if x==x%COMPRESS_ADDRESS% (
  call :cpy %SOURCE_DIR%\%TARGET_FILE% %TARGET_DIR%\%TARGET_FILE%
) else (
  %EXOMIZER% sfx %COMPRESS_ADDRESS% %SOURCE_DIR%\%TARGET_FILE% -t 168 -o %TARGET_DIR%\%TARGET_FILE% -q
  if ERRORLEVEL 1 goto :exomizer_error
  if NOT ERRORLEVEL 0 goto :exomizer_error
)

rem If there is a matching .txt file, it is copied as well
if exist %SOURCE_DIR%\%ENTRY%.txt call :cpy %SOURCE_DIR%\%ENTRY%.txt %TARGET_DIR%\%ENTRY%.txt
goto :eof

rem Copy single file. The echo commands creates the file, so XCOPY does not ask if file or directory
:cpy
echo Copying %1 to %2
echo Nothing >%2
xcopy /I /Y %1 %2
if ERRORLEVEL 1 goto :copy_error
goto :eof

:mads_error
echo ERROR: MADS compilation errors occurred. Check error messages above.
exit

:exomizer_error
echo ERROR: Exomizer errors occurred. Check error messages above.
exit

:copy_error
echo ERROR: Copy errors occurred. Check error messages above.
exit